Index: /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref
===================================================================
--- /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5045)
+++ /branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5046)
@@ -18,6 +18,4 @@
    ln_limdyn     = .true.          !  ice dynamics (T) or thermodynamics only (F)
    amax          = 0.999           !  maximum ice concentration
-   cai           = 1.40e-3         !  atmospheric drag over sea ice (clio)
-   cao           = 1.00e-3         !  atmospheric drag over ocean   (clio)
    ln_nicep      = .false.         !  Ice points output for debug (yes or no)
    ln_limdiahsb  = .false.          !  check the heat and salt budgets (T) or not (F)
@@ -31,10 +29,10 @@
    hts_ini_n   =  0.3      !  initial snow thickness in the north
    hts_ini_s   =  0.3      !        "            "          south
-   hti_ini_n   =  1.0      !  initial ice thickness in the north
+   hti_ini_n   =  3.0      !  initial ice thickness in the north
    hti_ini_s   =  1.0      !        "            "         south
    ati_ini_n   =  0.9      !  initial ice concentration in the north
    ati_ini_s   =  0.9      !        "            "             south
-   smi_ini_n   =  6.301    !  initial ice salinity in the north
-   smi_ini_s   =  6.301    !        "            "    south
+   smi_ini_n   =  6.3      !  initial ice salinity in the north
+   smi_ini_s   =  6.3      !        "            "    south
    tmi_ini_n   =  270.     !  initial ice/snw temp in the north
    tmi_ini_s   =  270.     !  initial ice/snw temp in the south
@@ -43,6 +41,4 @@
 &namicedyn     !   ice dynamic
 !-----------------------------------------------------------------------
-   epsd        =   1.0e-20 !  tolerance parameter
-   om          =   0.5     !  relaxation constant 
    cw          =   5.0e-03 !  drag coefficient for oceanic stress
    pstar       =   2.0e+04 !  1st bulk-rheology parameter
@@ -50,8 +46,7 @@
    creepl      =   1.0e-12 !  creep limit
    ecc         =   2.0     !  eccentricity of the elliptical yield curve
-   ahi0        = 350.e0    !  horizontal eddy diffusivity coefficient for sea-ice [m2/s]
+   ahi0        = 350.e0    !  horizontal eddy diffusivity coefficient for sea-ice [m2/s] ! depends on resolution
    nevp        = 120       !  number of iterations for subcycling in EVP
    relast      = 0.333     !  ratio of elastic timescale over ice time step (1/3 if nevp=120 ; 1/9 if nevp=300)
-   alphaevp    =   1.0     !  coefficient for the solution of internal ice stresses
    hminrhg     =   0.001   !  ice volume (a*h in m) below which ice velocity equal ocean velocity
 /
@@ -59,5 +54,4 @@
 &namicethd     !   ice thermodynamic
 !-----------------------------------------------------------------------
-   hmelt       = -0.15     !  maximum melting at the bottom
    hiccrit     = 0.1       !  ice thickness for lateral accretion 
                            !         caution 1.0, 1.0 best value to be used!!! (gilles G.)  ????
@@ -66,7 +60,5 @@
    vfrazb      = 0.4166667 !  thresold drift speed for frazil ice collecting at the ice bottom
    Cfrazb      = 5.0       !  squeezing coefficient for frazil ice collecting at the ice bottom
-   hiclim      = 0.10      !  minimum ice thickness
-   hnzst       = 0.1       !  thickness of the surf. layer in temp. computation
-   parsub      = 1.0       !  switch for snow sublimation or not
+   hiclim      = 0.10      !  minimum thickness of the first thickness category, must be smaller than hiccrit
    betas       = 0.6       !  exponent in lead-ice fractionation of snow precipitation 0.66
                            !        betas = 1 -> equipartition, betas < 1 -> more on leads
@@ -91,6 +83,4 @@
    s_i_max     = 20.0      !  Maximum salinity 
    s_i_min     =  0.1      !  Minimum tolerated ice salinity
-   s_i_0       =  3.5      !  1st salinity for salinity profile
-   s_i_1       =  4.5      !  2nd salinity for salinity profile
 /
 !-----------------------------------------------------------------------
@@ -111,16 +101,2 @@
    partfun_swi      =   1    !  participation function linear, TH75 (0) or exponential Letal07 (1)
    brinstren_swi    =   0    !  (1) use brine volume to diminish ice strength
-/
-!-----------------------------------------------------------------------
-&namicedia     !   ice diagnostics
-!-----------------------------------------------------------------------
-   fmtinf      ='1PE13.5 ' !  format of the output values
-   nfrinf      = 4         !  number of variables written in one line
-   ntmoy       = 1         !  instantaneous values of ice evolution or averaging
-   ninfo       = 1         !  frequency of ouputs on file ice_evolu in case of averaging
-/
-!!-----------------------------------------------------------------------
-!&namicehsb       !  Heat and salt budgets 
-!!-----------------------------------------------------------------------
-!/
-