Index: branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref
===================================================================
--- branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5046)
+++ branches/2015/dev_r5044_CNRS_LIM3CLEAN/NEMOGCM/CONFIG/SHARED/namelist_ice_lim3_ref	(revision 5048)
@@ -2,7 +2,7 @@
 !! NEMO/LIM3 :  1 - dynamics/advection/thermo          (namicerun)
 !! namelists    2 - ice intialisation                  (namiceini)
-!!              3 - ice dynamic                        (namicedyn)
+!!              3 - ice dynamics                       (namicedyn)
 !!              4 - ice advection                      (namicetrp)
-!!              5 - thermodynamic                      (namicethd)
+!!              5 - thermodynamics                     (namicethd)
 !!              6 - ice salinity                       (namicesal)
 !!              7 - mechanical redistribution of ice   (namiceitdme)
@@ -17,86 +17,83 @@
    cn_icerst_out = "restart_ice"   !  suffix of ice restart name (output)
    ln_limdyn     = .true.          !  ice dynamics (T) or thermodynamics only (F)
-   amax          = 0.999           !  maximum ice concentration
-   ln_nicep      = .false.         !  Ice points output for debug (yes or no)
-   ln_limdiahsb  = .false.          !  check the heat and salt budgets (T) or not (F)
+   amax          = 0.999           !  maximum tolerated ice concentration
+   ln_nicep      = .false.         !  ice points output for debug (yes or no)
+   ln_limdiahsb  = .false.         !  check the heat and salt budgets (T) or not (F)
    ln_limdiaout  = .true.          !  output the heat and salt budgets (T) or not (F)
 /
 !-----------------------------------------------------------------------
-&namiceini     !   ice initialisation
+&namiceini     !   ice initialization
 !-----------------------------------------------------------------------
    ln_limini   = .false.   !  activate ice initialization (T) or not (F)
    thres_sst   =  0.0      !  threshold water temperature for initial sea ice
-   hts_ini_n   =  0.3      !  initial snow thickness in the north
-   hts_ini_s   =  0.3      !        "            "          south
-   hti_ini_n   =  3.0      !  initial ice thickness in the north
-   hti_ini_s   =  1.0      !        "            "         south
-   ati_ini_n   =  0.9      !  initial ice concentration in the north
-   ati_ini_s   =  0.9      !        "            "             south
-   smi_ini_n   =  6.3      !  initial ice salinity in the north
-   smi_ini_s   =  6.3      !        "            "    south
-   tmi_ini_n   =  270.     !  initial ice/snw temp in the north
-   tmi_ini_s   =  270.     !  initial ice/snw temp in the south
+   hts_ini_n   =  0.3      !  initial snow thickness (North)
+   hts_ini_s   =  0.3      !        "            "   (South)
+   hti_ini_n   =  3.0      !  initial ice thickness  (North)
+   hti_ini_s   =  1.0      !        "            "   (South)
+   ati_ini_n   =  0.9      !  initial ice concentration (North)
+   ati_ini_s   =  0.9      !        "            "      (South)
+   smi_ini_n   =  6.3      !  initial ice salinity   (North)
+   smi_ini_s   =  6.3      !        "            "   (South)
+   tmi_ini_n   =  270.     !  initial ice/snw temp   (North)
+   tmi_ini_s   =  270.     !  initial ice/snw temp   (South)
 /
 !-----------------------------------------------------------------------
-&namicedyn     !   ice dynamic
+&namicedyn     !   ice dynamics
 !-----------------------------------------------------------------------
-   cw          =   5.0e-03 !  drag coefficient for oceanic stress
-   pstar       =   2.0e+04 !  1st bulk-rheology parameter
+   cw          =   5.0e-03 !  ice-ocean drag coefficient
+   pstar       =   2.0e+04 !  1st bulk-rheology parameter (N/m)
    c_rhg       =  20.0     !  2nd bulk-rhelogy parameter
-   creepl      =   1.0e-12 !  creep limit
+   creepl      =   1.0e-12 !  creep limit (s-1)
    ecc         =   2.0     !  eccentricity of the elliptical yield curve
-   ahi0        = 350.e0    !  horizontal eddy diffusivity coefficient for sea-ice [m2/s] ! depends on resolution
-   nevp        = 120       !  number of iterations for subcycling in EVP
-   relast      = 0.333     !  ratio of elastic timescale over ice time step (1/3 if nevp=120 ; 1/9 if nevp=300)
-   hminrhg     =   0.001   !  ice volume (a*h in m) below which ice velocity equal ocean velocity
+   ahi0        = 350.e0    !  horizontal eddy diffusivity coefficient for sea-ice (m2/s), depends on resolution
+   nevp        = 120       !  number of EVP subcycles
+   relast      =   0.333   !  ratio of elastic timescale to ice time step (1/3 if nevp=120, 1/9 if nevp=300)
+   hminrhg     =   0.001   !  ice volume (a*h in m) below which ice velocity equals ocean velocity
 /
 !-----------------------------------------------------------------------
-&namicethd     !   ice thermodynamic
+&namicethd     !   ice thermodynamics
 !-----------------------------------------------------------------------
-   hiccrit     = 0.1       !  ice thickness for lateral accretion 
-                           !         caution 1.0, 1.0 best value to be used!!! (gilles G.)  ????
-   fraz_swi    = 0         !  use of frazil ice collection thickness in function of wind (1.0) or not (0.0)
+   hiccrit     = 0.1       !  thickness for new ice formation in open water
+   fraz_swi    = 0         !  use frazil ice collection thickness as a function of wind (1.0) or not (0.0)
    maxfrazb    = 0.0       !  maximum portion of frazil ice collecting at the ice bottom
-   vfrazb      = 0.4166667 !  thresold drift speed for frazil ice collecting at the ice bottom
+   vfrazb      = 0.417     !  thresold drift speed for frazil ice collecting at the ice bottom
    Cfrazb      = 5.0       !  squeezing coefficient for frazil ice collecting at the ice bottom
    hiclim      = 0.10      !  minimum thickness of the first thickness category, must be smaller than hiccrit
    betas       = 0.6       !  exponent in lead-ice fractionation of snow precipitation 0.66
                            !        betas = 1 -> equipartition, betas < 1 -> more on leads
-   kappa_i     = 1.0       !  extinction radiation parameter in sea ice (1.0)
+   kappa_i     = 1.0       !  extinction radiation parameter in sea ice (m-1)
    nconv_i_thd = 50        !  maximal number of iterations for heat diffusion computation
-   maxer_i_thd = 0.0001    !  maximal error in temperature for heat diffusion computation
-   thcon_i_swi = 1         !  switch for computation of thermal conductivity in the ice
-                           !        (0) Untersteiner (1964), (1) Pringle et al. (2007)
+   maxer_i_thd = 0.0001    !  temperature error tolerance after heat diffusion 
+   thcon_i_swi = 1         !  sea ice thermal conductivity, Untersteiner_64 (0) or Pringle_et_al_07 (1)
+   nn_monocat  = 0         !  virtual ITD mono-category parameterizations (1) or not (0); 1 ok for jpl=1 only
+                           !  2=replace ridging by piling, 3=activate G(he) only, 4=activate lateral melting only) --- those are temporary test options
 /
 !-----------------------------------------------------------------------
 &namicesal     !   ice salinity
 !-----------------------------------------------------------------------
-   num_sal     =  2        !  salinity option: 1 -> S = bulk_sal
-                           !                   2 -> S = S(z,t) with a simple parameterization
-                           !                   3 -> S = S(z) profile of Scwharzacher [1959]
-                           !                   4 -> S = S(h) Cox and Weeks [1974]
+   num_sal     =  2        !  S=bulk_sal (1), S(z,t) - (2), S(z) Schwarzacher_59 (3) 
    bulk_sal    =  4.0      !  if 1 is used, it represents the ice salinity
-   sal_G       =  5.00     !  restoring salinity for GD
-   time_G      =  1.728e+6 !  restoring time for GD
-   sal_F       =  2.00     !  restoring salinity for flushing
-   time_F      =  8.640e+5 !  restoring time for flushing
-   s_i_max     = 20.0      !  Maximum salinity 
-   s_i_min     =  0.1      !  Minimum tolerated ice salinity
+   sal_G       =  5.00     !  restoring salinity, gravity drainage (g/kg)
+   time_G      =  1.728e+6 !  restoring time scale, gravity drainage  (s)
+   sal_F       =  2.00     !  restoring salinity, flushing (g/kg)
+   time_F      =  8.640e+5 !  restoring time, flushing (s)
+   s_i_max     = 20.0      !  maximum tolerated ice salinity (g/kg)
+   s_i_min     =  0.1      !  minimum tolerated ice salinity (g/kg)
 /
 !-----------------------------------------------------------------------
 &namiceitdme   !   parameters for mechanical redistribution of ice 
 !-----------------------------------------------------------------------
-   ridge_scheme_swi = 0      !  which ridging scheme using (1=Rothrock,else=Hibler79)
-   Cs               =   0.50 !  shearing energy contribution to ridging
-   Cf               =  17.0  !  ratio of ridging work to PE change in ridging
-   fsnowrdg         =   0.5  !  snow fraction that survives in ridging
-   fsnowrft         =   0.5  !  snow fraction that survives in rafting
-   Gstar            =   0.15 !  fractional area of thin ice being ridged
-   astar            =   0.05 !  equivalent of gstar (0.05 for TH75 and 0.03 for weaker ice)
-   Hstar            = 100.0  !  parameter determining the maximum thickness of ridged ice
-   raft_swi         =   1    !  rafting or not
-   hparmeter        =   0.75 !  threshold thickness for rafting or not
+   ridge_scheme_swi =   0    !  ice strength parameteriztaion, Hibler_79 (0), Rothrock_75 (1)
+   Cs               =   0.50 !  ratio of shearing energy contributing to ridging
+   Cf               =  17.0  !  ratio of ridging work to potential energy change in ridging
+   fsnowrdg         =   0.5  !  snow volume fraction that survives in ridging
+   fsnowrft         =   0.5  !  snow volume fraction that survives in rafting
+   Gstar            =   0.15 !  fractional area of thin ice being ridged (partfun_swi = 0)
+   astar            =   0.05 !  measures fractional area of thin ice being ridged (partfun_swi = 1)
+   Hstar            = 100.0  !  determines the maximum thickness of ridged ice (m)
+   raft_swi         =   1    !  rafting activated (1) or not (0)
+   hparmeter        =   0.75 !  threshold thickness for rafting (m)
    Craft            =   5.0  !  coefficient used in the rafting function
-   ridge_por        =   0.3  !  initial porosity of the ridged ice (typically 0.30)
-   partfun_swi      =   1    !  participation function linear, TH75 (0) or exponential Letal07 (1)
-   brinstren_swi    =   0    !  (1) use brine volume to diminish ice strength
+   ridge_por        =   0.3  !  porosity of newly ridged ice
+   partfun_swi      =   1    !  participation function: linear, Thorndike et al 75 (0) or exponential, Lipscomb 07 (1)
+   brinstren_swi    =   0    !  ice strength is a function of brine volume fraction (1) or not (0)